﻿﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
namespace $safeprojectname$.App.Code.Data
{
    public class SessionManager
    {
        private HttpContext _context;
        private Microsoft.Owin.IOwinContext _webContext;
        private SessionInfo _sessionInfo;
        private string session_id;
        private NFinal.ServerType _serverType = NFinal.ServerType.UnKnown;
        public SessionManager()
        {
            this._serverType = NFinal.ServerType.IsStatic;
            _sessionInfo = new SessionInfo();
        }
        public SessionManager(Microsoft.Owin.IOwinContext context)
        {
            this._webContext = context;
            this._serverType = NFinal.ServerType.MicrosoftOwin;
            _sessionInfo = new SessionInfo();
        }
        public SessionManager(HttpContext context)
        {
            this._context = context;
            this._serverType = NFinal.ServerType.AspNET;
            _sessionInfo = new SessionInfo();
        }
        public SessionManager(string session_id)
        {
            this.session_id = session_id;
            this._serverType = NFinal.ServerType.UnKnown;
            _sessionInfo = new SessionInfo();
        }
        public string SessionId
        {
            get
            {
                if (this._serverType == NFinal.ServerType.AspNET)
                {
                    if (_context.Request.Cookies["session_id"] != null)
                    {
                        this.session_id = _context.Request.Cookies["session_id"].Value;
                    }
                    else
                    {
                        this.session_id = Guid.NewGuid().ToString("N");
                        HttpCookie cookie = new HttpCookie("session_id", this.session_id);
                        _context.Response.Cookies.Add(cookie);
                    }
                }
                else if (this._serverType == NFinal.ServerType.MicrosoftOwin)
                {
                    if (_webContext.Request.Cookies["session_id"] != null)
                    {
                        this.session_id = _webContext.Request.Cookies["session_id"];
                    }
                    else
                    {
                        this.session_id = Guid.NewGuid().ToString("N");
                        _webContext.Response.Cookies.Append("session_id", this.session_id);
                    }
                }
                return this.session_id;
            }
            set
            {
                this.session_id = value;
                if (this._serverType == NFinal.ServerType.AspNET)
                {
                    if (_context.Response.Cookies["session_id"] == null)
                    {
                        HttpCookie cookie = new HttpCookie("session_id", value);
                        _context.Response.Cookies.Add(cookie);
                    }
                    else
                    {
                        _context.Request.Cookies["session_id"].Value = value;
                    }
                }
                else if (this._serverType == NFinal.ServerType.MicrosoftOwin)
                {
                    if (_webContext.Request.Cookies["session_id"] != null)
                    {
                        _webContext.Response.Cookies.Delete("session_id");
                    }
                    _webContext.Response.Cookies.Append("session_id", value);
                }
            }
        }
        public int userId
        {
            get 
			{
				object obj = System.Runtime.Caching.MemoryCache.Default.Get(string.Format("s:{0}:{1}", SessionId, "userId"));
                if (obj != null)
                {
						_sessionInfo.userId=(int)obj;
                }
                return _sessionInfo.userId;
            }
            set 
			{
				_sessionInfo.userId = value;
                System.Runtime.Caching.MemoryCache.Default.Set(string.Format("s:{0}:{1}", SessionId, "userId"), _sessionInfo.userId, DateTimeOffset.Now.AddMinutes(30));
            }
        }
    }
}