﻿﻿//======================================================================
//
//        Copyright : Zhengzhou Strawberry Computer Technology Co.,LTD.
//        All rights reserved
//        
//        Application:NFinal MVC framework
//        Filename :Controller.cs
//        Description :控制器
//
//        created by Lucas at  2015-6-30`
//     
//        WebSite:http://www.nfinal.com
//
//======================================================================
using System;
using System.Collections.Generic;
using System.Web;
using System.Collections.Specialized;
using System.IO;
namespace $safeprojectname$.App
{
    //Controller基类
    public class Controller : NFinal.BaseAction
    {
        public Controller() { }
        public Controller(string fileName)
            : base(fileName)
        {
        }
        public Controller(TextWriter tw)
            : base(tw)
        {
        }
		public Controller(HttpContext context)
        {
            this._serverType = NFinal.ServerType.AspNET;
            this._tw = context.Response.Output;
            this._context = context;
            Cookie = new Code.Data.CookieManager(context);
            Session = new Code.Data.SessionManager(context);
        }
        public Controller(Microsoft.Owin.IOwinContext context)
        {
            this._serverType = NFinal.ServerType.MicrosoftOwin;
            StreamWriter sw = new StreamWriter(context.Response.Body);
            this._tw = sw;
            this._webContext = context;
            Cookie = new Code.Data.CookieManager(context);
        }

        public Controller(Controller controller) : base(controller)
        {
        }

        public void Error(string msg, string url, int second)
        {
            Web.Default.Common.Public.ErrorAction errorAction = new Web.Default.Common.Public.ErrorAction(_tw);
            errorAction.Error(msg, url, second);
        }
        public void Success(string msg, string url, int second)
        {
            Web.Default.Common.Public.SuccessAction successAction = new Web.Default.Common.Public.SuccessAction(_tw);
            successAction.Success(msg, url, second);
        }
        public void AjaxReturn<T>(List<T> obj)
        {
            this.AjaxReturn(obj.ToJson(), obj!=null && obj.Count>0  ? 1 : 0);
        }
        public Code.Data.CookieManager Cookie = new Code.Data.CookieManager();
        public Code.Data.SessionManager Session = new Code.Data.SessionManager();
    }
}